<script setup>
import MyWebsites from '../components/ListeWebsite.vue'
import WebsiteItem from '../components/WebsiteItem.vue'

import { ref, onMounted } from 'vue'

const data = ref(null)
const error = ref(null)

async function ajouter_website(e){
  e.cancelBubble = true;
  console.log(e);
  fetch ('https://api.mangaUpdate.fr/api/addWebsite', {
    method: 'POST',
    headers: {'Content-Type' : 'application/json'},
    body: JSON.stringify({
      'name':e.target.innerText,
      'token':sessionStorage.getItem('authentificated')
    })
  }).then((res) => res.json())
    .then(() => location.reload())
    .catch((err) => (error.value = err))
}

function envoyer_suggestion_site(e){
  fetch ('https://api.mangaUpdate.fr/api/suggestWebsite', {
    method: 'POST',
    headers: {'Content-Type' : 'application/json'},
    body: JSON.stringify({
      'url':e.srcElement[0].value,
      'token':sessionStorage.getItem('authentificated')
    })
  }).then((res) => res.json())
    .then(() => document.getElementById('fermer_overlay_suggerer_website').click())
    .catch((err) => (error.value = err))
}

fetch ('https://api.mangaUpdate.fr/api/otherWebsites', {
  method: 'POST',
  headers: {'Content-Type' : 'application/json'},
  body: JSON.stringify({
    'token':sessionStorage.getItem('authentificated')
  })
}).then((res) => res.json())
  .then((json) => (data.value = json))
  .catch((err) => (error.value = err))

onMounted(() => {
  document.getElementById('search_website').firstElementChild.addEventListener('keyup', async function(){
    fetch ('https://api.mangaUpdate.fr/api/findWebsites', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'name':document.getElementById('search_website').firstElementChild.value,
        'token':sessionStorage.getItem('authentificated')
      })
    }).then((res) => res.json())
      .then((json) => (data.value = json))
      .catch((err) => (error.value= err))
  })
 
  
})
</script>

<template>
  <main class="container mx-auto flex flex-col items-center pt-8">
    <MyWebsites />
    <label class='flex justify-center my-4 mx-auto p-2 bg-gray-300' id="add_website" for="ajouter_website">
      <font-awesome-icon class='h-10 text-gray-600' icon="fa-solid fa-plus"/>
    </label>
  </main>
  <input type="checkbox" id="ajouter_website" class='hidden peer/overlay'/>
  <div id="overlay_ajouter_website" class="group flex flex-col peer-checked/overlay:z-20 peer-checked/overlay:opacity-100 peer-checked/overlay:h-screen h-0 w-full absolute top-0 left-0 opacity-0 z-0 transition-75 overflow-hidden">
    <div id="overlay" class="bg-black opacity-70 absolute top-0 left-0 h-full w-full"></div>
    <label class='flex my-20 mx-auto justify-center p-4 bg-gray-300 rounded-full w-24' id="fermer_overlay_website" for="ajouter_website">
      <font-awesome-icon icon="fa-solid fa-xmark" class="h-16 text-red-600"/>
    </label>
    <div id="menu_ajout_website" class="bg-zinc-600 py-8 px-20 h-full flex flex-col items-center">
        
      <form id="search_website" action="javascript:void(0);">
        <input type="text" placeholder="Recherche" class="rounded-xl py-1 px-8 bg-zinc-300 w-full text-black text-center">
      </form>
      <div v-if="error" class="error">{{ error }}</div>
      <div v-else-if="data" class="content self-stretch lg:grid lg:gap-2 lg:grid-cols-2 xl:grid-cols-3 2xl:grid-cold-4">
        <li class='list-none elm_list_website' v-for="website in data" @click="ajouter_website">
          <WebsiteItem>
            <template #name>
              <h2>
                {{ website.name }}
              </h2>
            </template>
          </WebsiteItem>
        </li>
      </div>
      <div v-else="loading" class="loading">Loading...</div>
      <label for="suggerer_website" id="demande_nouveau_site" class="flex justify-center bg-zinc-500 rounded p-4 absolute bottom-8">
        <p>Proposer un nouveau site</p>
      </label>
    </div>
  </div>
  <input type="checkbox" id="voir_updates" class='hidden peer/overlay_updates'/>
  <div id="overlay_voir_updates" class="group flex flex-col peer-checked/overlay_updates:z-20 peer-checked/overlay_updates:opacity-100 peer-checked/overlay_updates:h-screen h-0 w-full absolute top-0 left-0 opacity-0 z-0 transition-75 overflow-y-scroll">
    <div id="overlay_updates" class="bg-black opacity-70 absolute top-0 left-0 h-full w-full"></div>
    <div id="menu_voir_updates" class="bg-zinc-600 mt-32 px-4">
      <label class='flex my-2 ms-auto justify-center p-1 bg-gray-300 rounded-full w-10 sticky top-8 z-10' id="fermer_overlay_voir_updates" for="voir_updates">
        <font-awesome-icon icon="fa-solid fa-xmark" class="h-8 text-red-600"/>
      </label>
      <div class="loading">Loading...</div>
    </div>
  </div>
  <input type="checkbox" id="suggerer_website" class='hidden peer/overlay_suggerer_website'/>
  <div id="overlay_voir_sites" class="group flex flex-col peer-checked/overlay_suggerer_website:z-30 peer-checked/overlay_suggerer_website:opacity-100 peer-checked/overlay_suggerer_website:h-screen h-0 w-full absolute top-0 left-0 opacity-0 z-0 transition-75 overflow-y-scroll">
    <div id="overlay_suggerer_website" class="bg-black opacity-70 absolute top-0 left-0 h-full w-full"></div>
    <div id="menu_voir_sites" class="bg-zinc-600 my-auto px-4">
      <label class='flex my-2 ms-auto justify-center p-1 bg-gray-300 rounded-full w-10 sticky top-8 z-10' id="fermer_overlay_suggerer_website" for="suggerer_website">
        <font-awesome-icon icon="fa-solid fa-xmark" class="h-8 text-red-600"/>
      </label>
      <form action="javascript:;" @submit="envoyer_suggestion_site" class="my-6">
        <div class="flex justify-center items-baseline">
          <label for="nouveau_website_suggestion" class="mr-2">Lien du site :</label>
          <input type="text" id="nouveau_website_suggestion" class="rounded-xl py-1 px-8 bg-zinc-300 text-black text-center">
        </div>
        <input type="submit" class="flex justify-center bg-zinc-500 rounded px-4 py-2 mx-auto mt-4">
      </form>
    </div>
  </div>
</template>

<style>

@tailwind base;
@tailwind components;
@tailwind utilities;

.content{
  overflow-x: hidden;
}

</style>